
import java.io.IOException;
import java.io.PrintWriter;
import html.HtmlWriter;
import html.Parser;
import html.Parser.IntParametr;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

public class SeznamCiselServlet extends HttpServlet {

    public static final String sessionPrefix = "SeznamCiselServlet.";

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setCharacterEncoding("utf-8");

        PrintWriter out = response.getWriter();
        HttpSession session = request.getSession();
        Integer pocet = (Integer) session.getAttribute(TvarGrafuServlet.sessionPrefix + "pocet");
        String[] sessValues = (String[]) session.getAttribute(sessionPrefix + "values");
        String[] values;
        if (pocet != null) {
            values = new String[pocet];
            if (sessValues != null) {
                for (int i = 0; i < Math.min(sessValues.length, pocet); i++) {
                    values[i] = sessValues[i];
                }
            }
        } else {
            values = sessValues;
        }
        if (values == null) {
            values = new String[0];
        }
        printPage(out, values, new String[values.length]);
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        HttpSession session = request.getSession();
        Integer pocet = (Integer) session.getAttribute(TvarGrafuServlet.sessionPrefix + "pocet");
        if(pocet == null) pocet = 0;
        String[] values = new String[pocet];
        String[] errors = new String[pocet];


        for (int i = 0; i < pocet; i++) {
            IntParametr p = Parser.getIntParametr(request, String.format("hodnota%d", i), 1);
            values[i] = p.parametr;
            if (p.error != 0) {
                switch (p.error) {
                    case 1:
                        errors[i] = "Zadejte číslo!";
                        break;
                    case 2:
                        errors[i] = "Počet není platné číslo!";
                        break;
                    case 3:
                        errors[i] = "Zadejte číslo &gt; 0!";
                        break;
                }
            }
        }

        for (int i = 0; i < errors.length; i++) {
            if (errors[i] != null) {
                response.setCharacterEncoding("utf-8");
                PrintWriter out = response.getWriter();
                printPage(out, values, errors);
                return;
            }
        }
        session.setAttribute(sessionPrefix + "values", values);
        response.sendRedirect(response.encodeRedirectURL("graf"));
    }

    private void printPage(PrintWriter out, String[] values, String[] errors) {
        HtmlWriter.printHeader(out, "Koláčový graf");
        out.println("<h2>Krok 2</h2>");
        out.println("<p>Zadejte prosím hodnoty grafu.</p>");


        out.println("<form method=\"post\" action=\"seznam-cisel\"><fieldset>");
        out.println("<table border=\"0\">");
        for (int i = 0; i < values.length; i++) {
            HtmlWriter.printInputTableRow(out, String.format("Hodnota %02d:", i + 1),
                    String.format("hodnota%d", i), values[i], errors[i]);
        }
        out.println("</table>");
        out.println("<input type=\"submit\" name=\"submit\" /></fieldset></form>");
        HtmlWriter.printFooter(out);
    }
}
